<template>
  <div>
    <v-navigation-drawer
      app
      v-model="drawer"
      :mini-variant="isMobile ? false : mini"
      :temporary="isMobile"
      :permanent="!isMobile"
    >
      <v-list-item :class="mini ? 'py-1 px-2' : ''">
        <v-list-item-avatar
          @click="isMobile ? (drawer = !drawer) : miniToggle()"
        >
          <v-img
            contain
            aspect-ratio="1.1"
            src="@/assets/yogya-logo.png"
          ></v-img>
        </v-list-item-avatar>

        <v-list-item-content>
          <v-list-item-title class="title">
            MyTraining
          </v-list-item-title>
          <v-list-item-subtitle>
            Web Admin
          </v-list-item-subtitle>
        </v-list-item-content>

        <v-btn icon @click.stop="isMobile ? (drawer = !drawer) : miniToggle()">
          <v-icon>mdi-chevron-left</v-icon>
        </v-btn>
      </v-list-item>

      <v-list dense nav shaped class="mt-3">
        <div v-for="access in sidebarData" :key="access.name">
          <v-list-group
            v-if="access.sub !== undefined"
            link
            :to="access.to"
            no-action
            :prepend-icon="access.icon"
            :append-icon="access.hasSub ? undefined : ''"
          >
            <template v-slot:activator>
              <v-list-item-title>{{ access.name }}</v-list-item-title>
            </template>

            <v-list-item
              v-for="subAccess in access.sub"
              :key="subAccess.name"
              link
              exact
              :to="`${access.to}/${subAccess.to}`"
            >
              <v-list-item-content>
                <v-list-item-title>{{ subAccess.name }}</v-list-item-title>
              </v-list-item-content>
            </v-list-item>
          </v-list-group>

          <v-list-item v-else link exact :to="access.to">
            <v-list-item-icon>
              <v-icon>{{ access.icon }}</v-icon>
            </v-list-item-icon>

            <v-list-item-content>
              <v-list-item-title>{{ access.name }}</v-list-item-title>
            </v-list-item-content>
          </v-list-item>
        </div>
      </v-list>
    </v-navigation-drawer>
    <!-- header -->
    <v-app-bar elevation="0" color="transparent" app>
      <div class="d-flex flex-row justify-space-between">
        <v-btn icon v-if="isMobile" class="pt-2" @click="drawer = true">
          <v-icon>mdi-menu</v-icon>
        </v-btn>

        <v-menu bottom offset-y>
          <template v-slot:activator="{ on }">
            <div
              class="outlet-list d-flex flex-row justify-space-between align-center cursor-pointer px-2"
              v-on="on"
            >
              <div>
                <v-icon color="black">mdi-store</v-icon>
              </div>
              <div class="d-flex flex-column ml-4 mt-5">
                <p class="mb-0 text-bold-sm">Outlet</p>
                <p class="black40">{{ outlet }}</p>
              </div>
              <div>
                <v-icon color="black" class="ml-10">mdi-menu-down</v-icon>
              </div>
            </div>
          </template>
          <v-card>
            <v-list>
              <v-list-item
                v-for="(item, i) in outletList"
                :key="i"
                @click="setOutlet(item)"
              >
                <v-list-item-title>{{ item.outlet_name }}</v-list-item-title>
              </v-list-item>
            </v-list>
          </v-card>
        </v-menu>
      </div>
      <v-spacer></v-spacer>
      <v-menu
        v-model="menu"
        :close-on-content-click="false"
        :nudge-width="100"
        max-width="300"
        offset-x
      >
        <template v-slot:activator="{ on, attrs }">
          <v-btn icon class="mr-2" elevation="2" small v-bind="attrs" v-on="on">
            <v-avatar width="30" height="30">
              <img
                contain
                src="https://rswijayakusuma.com/wp-content/uploads/2017/12/fb.jpg"
              />
            </v-avatar>
          </v-btn>
        </template>

        <v-card>
          <v-list>
            <v-list-item>
              <v-list-item-content>
                <v-list-item-title>Steve Jobs</v-list-item-title>
                <v-list-item-subtitle>IT</v-list-item-subtitle>
              </v-list-item-content>
              <v-list-item-action>
                <v-btn class="primary--text" icon>
                  <v-icon>mdi-account-settings</v-icon>
                </v-btn>
              </v-list-item-action>
            </v-list-item>
          </v-list>
          <v-divider></v-divider>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn text @click="onLogout">
              Logout
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-menu>
    </v-app-bar>
  </div>
</template>

<script>
import Cookies from "js-cookie";
import { sidebar } from "@/router/nav";

export default {
  name: "NavNavigationBar",
  data() {
    return {
      mini: false,
      menu: false,
      drawer: false,
      isMobile: false,
      outlet: null,
      outletList: [
        {
          outlet_name: "GBB"
        },
        {
          outlet_name: "ATP"
        }
      ]
    };
  },
  computed: {
    sidebarData() {
      return sidebar;
    }
  },
  methods: {
    setOutlet(val) {
      //action
      // this.$store.commit("outlet/SET_ID_OUTLET", val.outlet_id);
      // Cookies.set("id-outlet", val.outlet_id);
      // this.$store.dispatch("outlet/getList");
      // this.refreshToken();
      this.outlet = val.outlet_name;
    },
    onResize() {
      this.isMobile = window.innerWidth < 600;
    },
    miniToggle() {
      this.mini = !this.mini;
    },
    onLogout() {
      Cookies.remove("token");
      Cookies.remove("data_user");
      this.$nextTick(() => {
        this.$router.go();
      });
    }
  },
  mounted() {
    this.onResize();

    window.addEventListener("resize", this.onResize, { passive: true });
  },
  beforeDestroy() {
    if (typeof window === "undefined") return;

    window.removeEventListener("resize", this.onResize, { passive: true });
  }
};
</script>
